/* This code tests the functionality of the GeedotButton widget
 * 
 * Author: Luke Crowthers
 * File: GeedotButton.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *root;
	GeedotWidget *gframe;
	GeedotWidget *gcombo;
	GeedotArea area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;

	display = XOpenDisplay(display_name);
	area.x = 0;
	area.y = 0;
	area.width = 200;
	area.height = 200;
	root = gdot_get_root_widget(display);

	gframe = gdot_add_toplevel_frame(root, area);
	area.x = 10;
	area.y = 10;
	area.width = -1;
	area.height = -1;
	gcombo = gdot_add_locked_combobox(gframe, area);
	gdot_add_combobox_entry(gcombo, "Option 1");
	gdot_add_combobox_entry(gcombo, "Option 2");
	gdot_add_combobox_entry(gcombo, "Longer Option");
	gdot_add_combobox_entry(gcombo, "The Longest Option");
	gdot_add_combobox_entry(gcombo, "Any Option");
	gdot_show_frame(gframe);
	gdot_redraw_widget(gcombo);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				gdot_widget_destroy(gcombo);
				gdot_widget_destroy(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
