/* This code tests the functionality of the GeedotFrame widget
 * 
 * Author: Luke Crowthers
 * File: GeedotFrame.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *gframe;
	GeedotArea gframe_area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;

	display = XOpenDisplay(display_name);
	gframe_area.x = 0;
	gframe_area.y = 0;
	gframe_area.width = 200;
	gframe_area.height = 200;

	gframe = gdot_add_toplevel_frame(gdot_get_root_widget(display), gframe_area);
	gdot_show_frame(gframe);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				//gdot_destroy_widget(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
