/* This code tests the functionality of the GeedotFrame widget
 * 
 * Author: Luke Crowthers
 * File: GeedotFrame.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *gframe;
	GeedotWidget *gradiolist;
	GeedotWidget *gradio;
	GeedotArea area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;

	display = XOpenDisplay(display_name);
	area.x = 0;
	area.y = 0;
	area.width = 200;
	area.height = 200;

	gframe = gdot_add_toplevel_frame(gdot_get_root_widget(display), area);
	area.x = 10;
	area.y = 10;
	area.width = 10;
	area.height = 10;
	gradiolist = gdot_add_radio_list(gframe, area);
	area.x = 0;
	area.y = 0;
	gradio = gdot_add_radio_button(gradiolist, area);
	gdot_redraw_widget(gradio);
	gdot_radio_button_set_label(gradio, "radio selection button number 1");
	area.y = gradio->area.y + gradio->area.height + 5;
	gradio = gdot_add_radio_button(gradiolist, area);
	gdot_redraw_widget(gradio);
	gdot_radio_button_set_label(gradio, "radio selection button number 2");
	area.y = gradio->area.y + gradio->area.height + 5;
	gradio = gdot_add_radio_button(gradiolist, area);
	gdot_redraw_widget(gradio);
	gdot_radio_button_set_label(gradio, "radio selection button number 3");
	gdot_show_frame(gframe);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				gdot_widget_destroy(gradio); 
				gdot_widget_destroy(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
