/* This code tests the functionality of the GeedotScrollbar widget
 * 
 * Author: Luke Crowthers
 * File: GeedotFrame.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *gframe;
	GeedotWidget *gscrollbar;
	GeedotArea area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;

	display = XOpenDisplay(display_name);
	area.x = 0;
	area.y = 0;
	area.width = 200;
	area.height = 200;

	gframe = gdot_add_toplevel_frame(gdot_get_root_widget(display), area);
	area.x = 200 - 15;
	area.y = 0;
	area.width = -1;
	area.height = 200 - 15;
	gscrollbar = gdot_add_scrollbar(gframe, area);
	gdot_scrollbar_set_percentage(gscrollbar, 50);
	gdot_redraw_widget(gscrollbar);
	area.x = 0;
	area.y = 200 - 15;
	area.width = 200 - 15;
	area.height = -1;
	gscrollbar = gdot_add_scrollbar(gframe, area);
	gdot_scrollbar_set_percentage(gscrollbar, 3.14159265358);
	gdot_redraw_widget(gscrollbar);
	gdot_show_frame(gframe);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				gdot_widget_destroy(gscrollbar); 
				gdot_widget_destroy(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
