/* This code tests the functionality of the GeedotText widget
 * 
 * Author: Luke Crowthers
 * File: GeedotText.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *gframe;
	GeedotWidget *gbutton;
	GeedotWidget *gtext;
	GeedotArea area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;
	
	display = XOpenDisplay(display_name);
	area.x = 0;
	area.y = 0;
	area.width = 200;
	area.height = 200;
	
	gframe = gdot_add_toplevel_frame(gdot_get_root_widget(display), area);
	gdot_show_frame(gframe);
	area.x = 10;
	area.y = 10;
	area.width = 180;
	area.height = 20;
	gbutton = gdot_add_button(gframe, area);
	area.x = 2;
	area.y = 2;
	gtext = gdot_add_text(gbutton, area, "hello you crazies");
	gdot_text_set_as_label(gtext, gbutton);
	gdot_widget_shrinkwrap(gbutton);
	gbutton->area.width += 2;
	gbutton->area.height += 2;
	gdot_redraw_widget(gbutton);
	gtext->is_active = False;
	gdot_redraw_widget(gtext);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				gdot_widget_destroy(gbutton);
				gdot_widget_destroy(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
