/* This code tests the functionality of the GeedotFrame widget
 * 
 * Author: Luke Crowthers
 * File: GeedotFrame.c
 * Date: Jan 2001
 * License: GPL
 */

#include <gdtoolkit.h>

int main (int args, char *argvals[]) {
	GeedotWidget *gframe;
	GeedotWidget *gtextbox;
	GeedotArea area;
	Display *display;
	char *display_name = (char *) getenv("DISPLAY");
	XEvent event;

	display = XOpenDisplay(display_name);
	area.x = 0;
	area.y = 0;
	area.width = 200;
	area.height = 200;

	gframe = gdot_add_toplevel_frame(gdot_get_root_widget(display), area);

	area.x = 5;
	area.y = 5;
	area.width = 150;
	area.height = 100;
	gtextbox = gdot_add_button(gframe, area);
	gdot_redraw_widget(gtextbox);

	area.x = 10;
	area.y = 10;
	area.width = 100;
	area.height = 10;
	gtextbox = gdot_add_textbox(gtextbox, area);
	gdot_redraw_widget(gtextbox);
	gdot_textbox_set_text(gtextbox, "I'm a textbox");
	gdot_redraw_widget(gtextbox);
	gdot_show_frame(gframe);

	while (1) {
		gdot_wait_for_event(gframe);
		event = gdot_process_next_event(gframe);
		if (event.type == ClientMessage) {
			if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(gframe->display, event.xclient.data.l[0]))) {
				gdot_widget_destroy(gtextbox); 
				gdot_widget_destroy(gframe);
				exit(0);
			}
		}
	}
	return 0;
}
