/* This code tests the functionality of the gdtoolkit
 * a gui toolkit designed for the  Geedot Web-Browser
 * project.
 * 
 * Author: Luke Crowthers
 * File: gdtktest.c
 * Date: Aug - Dec 2000
 * License: GPL
 */

#include <gdtoolkit.h>

int check_and_exit (GeedotWidget *);
int toggle_active (GeedotWidget *);
int but_toggle_active (GeedotWidget *);
int set_active (GeedotWidget *);
int radio_set_active (GeedotWidget *);
int set_unactive (GeedotWidget *);
int radio_set_unactive (GeedotWidget *);
int handle_keypress (GeedotWidget *, void *);
int vert_scrollbar_reset (GeedotWidget *, void *);
int horiz_scrollbar_reset (GeedotWidget *, void *);
void leave (void);

GeedotWidget *gradflipbutton;

int main (int args, char *argvals[]) {
	int x, y;
	int action_number;
	GeedotWidget *gbutton;
	GeedotWidget *gcheckbox;
	GeedotWidget *gradiolist;
	GeedotWidget *genableradio, *gdisableradio, *gradio;
	GeedotWidget *gtextbox;
	GeedotWidget *gvscrollbar;
	GeedotWidget *ghscrollbar;
	GeedotWidget *gcombobox;
	GeedotWidget *gcomboentry;
	GeedotWidget *test_frame;
	GeedotAction action;
	GeedotArea widget_area;
	Display *main_display;
	XEvent event;
	char *display_name = NULL;  /*( char *) getenv("DISPLAY"); */
	Pixmap pixmap;

	if (( main_display = XOpenDisplay(display_name) ) == NULL )
              {  printf("YUK1"); exit (-1); }
         else
             {  printf("YUK1 is OK\n");  }

	widget_area.x = 0;
	widget_area.y = 0;
	widget_area.width = 640;
	widget_area.height = 480;
	test_frame = gdot_add_toplevel_frame(gdot_get_root_widget(main_display), widget_area);
	gdot_show_frame(test_frame);



	widget_area.x = 100;
	widget_area.y = 100;
	widget_area.width = -1;
	widget_area.height = -1;

	gradiolist = gdot_add_radio_list(test_frame, widget_area);
	
	widget_area.x = 0;
	widget_area.y = 0;

	genableradio = gdot_add_radio_button(gradiolist, widget_area);
	gdot_radio_button_set_label(genableradio, "disable nothing");

   	widget_area.y = 18;
   
   	gdisableradio = gdot_add_radio_button(gradiolist, widget_area);
	gdot_radio_button_set_label(gdisableradio, "disable checkbox");
   
	widget_area.y = 36;
   
   	gradio = gdot_add_radio_button(gradiolist, widget_area);
   	gdot_radio_button_set_label(gradio, "disable textbox");
   
   	gdot_radio_button_set_selected(gradio);
   
   	widget_area.x = 1;
   	widget_area.y = 1;
   	widget_area.width = -1;
   	widget_area.height = -1;
   	gbutton = gdot_add_button(test_frame, widget_area);
   	gdot_button_set_label(gbutton, "button 1");

   	widget_area.x = (8 * 6) + 3;
   	widget_area.y = 1;
   	widget_area.width = -1;
   	widget_area.height = -1;
   	gbutton = gdot_add_button(test_frame, widget_area);
   	gdot_button_set_label(gbutton, "button 2");

   	widget_area.x = (8 * 6) * 2 + 5;
   	widget_area.y = 1;
   	widget_area.width = -1;
   	widget_area.height = -1;
   	gradflipbutton = gdot_add_button(test_frame, widget_area);
   	gdot_button_set_label(gradflipbutton, "deactivate radios");
   	action.trigger_mask = GeedotButtonRelease;
   	action.response = GEEDOT_FUNCTION(but_toggle_active);
   	action.response_data = genableradio;
   	gdot_register_widget_action(gradflipbutton, action);
   	action.response_data = gdisableradio;
   	gdot_register_widget_action(gradflipbutton, action);
   	action.response_data = gradio;
   	gdot_register_widget_action(gradflipbutton, action);
   
   	widget_area.x = 1;
   	widget_area.y = 45;
   	widget_area.width = -1;
   	widget_area.height = -1;
   	gbutton = gdot_add_button(test_frame, widget_area);
   	gdot_button_set_label(gbutton, "Exit gdtktest");
   	action.trigger_mask = GeedotButtonRelease;
   	action.response = GEEDOT_FUNCTION(leave);
   	action.response_data = 0;
   	gdot_register_widget_action(gbutton, action);

   	widget_area.x = 1;
   	widget_area.y = 30;
   	widget_area.width = -1;
   	widget_area.height = -1;
   	gcheckbox = gdot_add_checkbox(test_frame, widget_area);
   	gdot_checkbox_set_label(gcheckbox, "disallow exit");
   	action.trigger_mask = GeedotButtonRelease;
   	action.response = GEEDOT_FUNCTION(toggle_active);
   	action.response_data = gbutton;
   	gdot_register_widget_action(gcheckbox, action);
   
   	widget_area.x = 320;
   	widget_area.width = 470 - 320;
   	widget_area.y = 238;
   	gtextbox = gdot_add_textbox(test_frame, widget_area);
   	gdot_textbox_set_text(gtextbox, "Storing Text Works, and so does weird scrolling!");
   	gdot_redraw_textbox(gtextbox);
   
   	widget_area.x = 625;
   	widget_area.y = 0;
   	widget_area.width = -1;
   	widget_area.height = 463;
   	gvscrollbar = gdot_add_scrollbar(test_frame, widget_area);
   	GEEDOT_SCROLLBAR(gvscrollbar->widget_data)->percent = 50;
   	gdot_redraw_scrollbar(gvscrollbar);

   	widget_area.x = 0;
   	widget_area.y = 465;
   	widget_area.width = 624;
   	widget_area.height = -1;
   	ghscrollbar = gdot_add_scrollbar(test_frame, widget_area);
   	GEEDOT_SCROLLBAR(ghscrollbar->widget_data)->percent = 33;
   	gdot_redraw_scrollbar(ghscrollbar);

   	widget_area.x = 400;
   	widget_area.y = 10;
   	widget_area.width = -1;
   	widget_area.height = -1;
/*
   	pixmap = XCreatePixmap(test_frame->display, DefaultRootWindow(test_frame->display), 6, 3, 16);
*/
printf("YUK2 is OK\n");

   	pixmap = XCreatePixmap(test_frame->display,gdot_get_root_widget(main_display) , 6, 3, 16);


   	XSetForeground(test_frame->display, test_frame->frame_gc, test_frame->geedot_colors->light1.color.pixel);
   	XFillRectangle(test_frame->display, pixmap, test_frame->frame_gc, 0, 0, 6, 3);
   	XSetForeground(test_frame->display, test_frame->frame_gc, test_frame->geedot_colors->dark1.color.pixel);
   	XDrawLine(test_frame->display, pixmap, test_frame->frame_gc, 0, 0, 3, 0);
   	XSetForeground(test_frame->display, test_frame->frame_gc, test_frame->geedot_colors->mid1.color.pixel);
   	XDrawLine(test_frame->display, pixmap, test_frame->frame_gc, 1, 1, 2, 1);
   	XSetForeground(test_frame->display, test_frame->frame_gc, test_frame->geedot_colors->light2.color.pixel);
   	XDrawPoint(test_frame->display, pixmap, test_frame->frame_gc, 4, 0);
   	XDrawPoint(test_frame->display, pixmap, test_frame->frame_gc, 3, 1);
   	XDrawPoint(test_frame->display, pixmap, test_frame->frame_gc, 2, 2);
   	gdot_add_text_pixmap_button(test_frame, widget_area, "[no selection]", pixmap);

   	widget_area.x = 300;
   	widget_area.y = 300;
   	widget_area.width = 150;
  	widget_area.height = 15;
   	/*gcombobox = gdot_add_locked_combobox(test_frame, widget_area);
   	gdot_redraw_combobox(gcombobox);*/
   
   	action.trigger_mask = GeedotKeyPress;
   	action.response = GEEDOT_FUNCTION(handle_keypress);
   	action.response_data = gtextbox;
   	gdot_register_widget_action(gtextbox, action);

   	action.trigger_mask = GeedotButtonRelease;
   	action.response = GEEDOT_FUNCTION(set_active);
   	action.response_data = gcheckbox;
   	gdot_register_widget_action(genableradio, action);
   	action.response = GEEDOT_FUNCTION(set_active);
   	action.response_data = gtextbox;
   	gdot_register_widget_action(genableradio, action);

   	action.response = GEEDOT_FUNCTION(set_unactive);
   	action.response_data = gcheckbox;
   	gdot_register_widget_action(gdisableradio, action);
   	action.response = GEEDOT_FUNCTION(set_active);
   	action.response_data = gtextbox;
   	gdot_register_widget_action(gdisableradio, action);

   	action.response = GEEDOT_FUNCTION(set_active);
  	action.response_data = gcheckbox;
   	gdot_register_widget_action(gradio, action);
   	action.response = GEEDOT_FUNCTION(set_unactive);
   	action.response_data = gtextbox;
   	gdot_register_widget_action(gradio, action);
   
   	action.trigger_mask = GeedotFrameConfigure;
   	action.response = GEEDOT_FUNCTION(vert_scrollbar_reset);
   	action.response_data = gvscrollbar;
   	gdot_register_action(test_frame, action);
   
   	action.response = GEEDOT_FUNCTION(horiz_scrollbar_reset);
   	action.response_data = ghscrollbar;
   	gdot_register_action(test_frame, action);

   	gdot_radio_button_set_selected(genableradio);
   
   	while (1) {
		gdot_wait_for_event(test_frame);
      		event = gdot_process_next_event(test_frame);
      		if (event.type == ClientMessage) {
	 		if (!strcmp("WM_DELETE_WINDOW", XGetAtomName(test_frame->display, event.xclient.data.l[0]))) {
	    			check_and_exit(gcheckbox);
	 		}
      		}
   	}
   	return 0;
}

int check_and_exit (GeedotWidget *checkbox) {
   	if (((GeedotCheckbox *) checkbox->widget_data)->is_checked) {
      		return 0;
   	}
   	else {
      		exit(0);
   	}
}

int toggle_active (GeedotWidget *widget) {
   	widget->is_active = !widget->is_active;
   	gdot_redraw_widget(widget);
   	return 0;
}

int but_toggle_active (GeedotWidget *widget) {
   	toggle_active(widget);
   	if (widget->is_active) {
      		gdot_button_set_label(gradflipbutton, "deactivate radios");
   	}
   	else {
      		gdot_button_set_label(gradflipbutton, "reactivate radios");
   	}
   	gdot_redraw_button(gradflipbutton);
}

int set_active (GeedotWidget *widget) {
   	widget->is_active = True;
   	gdot_redraw_widget(widget);
   	return 0;
}

int radio_set_active (GeedotWidget *widget) {
}

int set_unactive (GeedotWidget *widget) {
   	widget->is_active = False;
   	gdot_redraw_widget(widget);
   	return 0;
}

void leave (void) {
   	exit(0);
}

int handle_keypress (GeedotWidget *widget, void *event_data) {
	char *keypress = XKeysymToString(XLookupKeysym(&((XEvent *) event_data)->xkey, 0));

	if (!strcasecmp("Return", keypress)) {
		if (!strcasecmp("exit", GEEDOT_TEXTBOX(widget->widget_data)->text)) {
			leave();
		}
		else {
			gdot_textbox_set_text(widget, "");
			GEEDOT_TEXTBOX(widget->widget_data)->cursor_stop = 2;
			GEEDOT_TEXTBOX(widget->widget_data)->cursor_start = 2;
			gdot_redraw_textbox(widget);
		}
	}
}

int vert_scrollbar_reset (GeedotWidget *widget, void *event_data) {
	widget->area.x = ((XEvent *) event_data)->xconfigure.width - 15;
	widget->area.width = 14;
	widget->area.y = 0;
	widget->area.height = ((XEvent *) event_data)->xconfigure.height - 15;
	gdot_redraw_widget(widget);

	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.x = 0;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.y = 0;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.width = 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.height = 14;
	gdot_redraw_widget(GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button);

	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.x = 0;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.y = widget->area.height - 15;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.width = 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.height = 14;
	gdot_redraw_widget(GEEDOT_SCROLLBAR(widget->widget_data)->increase_button);
}

int horiz_scrollbar_reset (GeedotWidget *widget, void *event_data) {
	widget->area.width = ((XEvent *) event_data)->xconfigure.width - 15;
	widget->area.x = 0;
	widget->area.y = ((XEvent *) event_data)->xconfigure.height - 15;
	widget->area.height = 14;
	gdot_redraw_widget(widget);

	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.x = 0;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.y = 0;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.width = 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button->area.height = 14;
	gdot_redraw_widget(GEEDOT_SCROLLBAR(widget->widget_data)->decrease_button);

	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.x = widget->area.width - 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.y = widget->area.height - 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.width = 14;
	GEEDOT_SCROLLBAR(widget->widget_data)->increase_button->area.height = 14;
	gdot_redraw_widget(GEEDOT_SCROLLBAR(widget->widget_data)->increase_button);
}
