/* Luke Crowthers - August 2000
 *  htget - http retreival code project
 *  htget.c - initialization and main control
 */

#include <stdio.h>
#include "gdhttp.h"

int gdot_http_get (char **header, char **data, char *url) {
   FILE *writeFile;
   TRANSFER_PROTOCOL protocol;
   int   strloc, argnum, stroff, length;
   int   sockfd, port;
   struct hostent *he;
   struct sockaddr_in server;
   char *remotehost, *remotepath, *request;
   char *hdrtokens[20];

   protocol = extract_transfer_protocol(url);
   extract_remote_host(&remotehost, url);
   puts(remotehost);
   extract_path(&remotepath, url);

   request = (char *) malloc((strlen(remotepath) + strlen(remotehost) + 23) * sizeof(char)); 

   strcpy(request, "GET ");
   strcat(request, remotepath);
   strcat(request, " HTTP/1.0\nhost: ");
   strcat(request, remotehost);
   strcat(request, "\n\n");

   he = gethostbyname(remotehost);
   if (he == NULL) {
      perror("gethostbyname");
      exit(1);
   }

   sockfd = socket(AF_INET, SOCK_STREAM, 0);
   if (sockfd == -1) {
      perror("socket");
      exit(1);
   }

   server.sin_family = AF_INET;
   if (port = extract_port(remotehost)) {
      server.sin_port = htons(port);
   }
   else {
      server.sin_port = htons(80);
   }
   server.sin_addr = *((struct in_addr *) he->h_addr);
   bzero(&(server.sin_zero), 8);

   if (connect(sockfd, (struct sockaddr *)&server, sizeof(struct sockaddr)) == -1) {
      perror("connect");
      exit(1);
   }
   http_req(sockfd, header, data, request);
   close(sockfd);
   
   return 0;
}

TRANSFER_PROTOCOL extract_transfer_protocol (char *transferURL) {
   int strloc;
   if (!strncasecmp(transferURL, "http://", 7)) {
      for (strloc = 7; strloc < strlen(transferURL); strloc++) {
	 transferURL[strloc - 7] = transferURL[strloc];
      }
      transferURL[strloc - 7] = '\0';
      return HTTP;
   }
   else if (!strncasecmp(transferURL, "ftp://", 6)) {
      for (strloc = 6; strloc < strlen(transferURL); strloc++) {
	 transferURL[strloc - 6] = transferURL[strloc];
      }
      transferURL[strloc - 6] = '\0';
      return FTP;
   }
   else if (!strncasecmp(transferURL, "file://", 7)) {
      for (strloc = 7; strloc < strlen(transferURL); strloc++) {
	 transferURL[strloc - 7] = transferURL[strloc];
      }
      transferURL[strloc - 7] = '\0';
      return DISK;
   }
   else {
      return HTTP;
   }
}

void extract_remote_host (char **hostname, char *hostURL) {
   int strloc;
   int delimoffset = -1;
   for (strloc = 0; strloc <= strlen(hostURL); strloc++) {
      if (hostURL[strloc] == '/') {
	 delimoffset = strloc;
	 break;
      }
   }
   if (delimoffset != -1) { /*Then a / delimeter was found*/
      *hostname = (char *) malloc(delimoffset * sizeof(char));
      strncpy(*hostname, hostURL, delimoffset);
   }
   else { /*Delimeter not found, the remainder of the url is hostname*/
      *hostname = (char *) malloc(strloc * sizeof(char));
      strncpy(*hostname, hostURL, strloc);
   }
   for (strloc = delimoffset; strloc <= strlen(hostURL); strloc++) { 
      hostURL[strloc - delimoffset] = hostURL[strloc];
   }
   hostURL[strloc - delimoffset] = '\0';
}

void extract_path (char **path, char *pathURL) {
   if (strcmp(pathURL, "")) {
      *path = (char *) malloc(strlen(pathURL) * sizeof(char));
      strcpy(*path, pathURL);
   }
   else {
      *path = (char *) malloc(2 * sizeof(char));
      strcpy(*path, "/");
   }
}

int extract_port (char *host) {
   int strloc, portnum;
   
   for (strloc = 0; strloc <= strlen(host); strloc++) {
      if (strloc == strlen(host)) {
	 return 0;
      }
      else if (host[strloc] == ':') {
	 break;
      }
   }
   strloc++;
   for(portnum = 0;strloc <= strlen(host); strloc++) {
      if (host[strloc] <= 57 && host[strloc] >= 48) {
	 portnum *= 10;
	 portnum += (host[strloc] - 48);
      }
      else {
	 fprintf(stderr, "port numbers may not be non-numerical");
	 return 0;
      }
   }
   return portnum;
}
