/* Geedot Toolkit - Widget set for Geedot Web Browser
 *   File: gdtoolkitgraphics.c - generic graphics draw functions to facilitate
 *                               code portability
 *   Author: Luke Crowthers
 *   Start Date: Feb, 2001
 *   Version: 0.1
 *   License: GPL
 */

#include <gdtoolkit.h>

int gdot_set_fg_color (GeedotWidget *widget, GeedotColor color) {
	widget->geedot_colors->foreground.value = color.value;
	widget->geedot_colors->foreground.color = color.color;
}

int gdot_set_bg_color (GeedotWidget *widget, GeedotColor color) {
	widget->geedot_colors->background.value = color.value;
	widget->geedot_colors->background.color = color.color;
}

int gdot_draw_point (GeedotWidget *widget, unsigned int x, unsigned int y) {
	int absx, absy;
	absx = gdot_widget_absolute_x(widget);
	absy = gdot_widget_absolute_y(widget);

	XDrawPoint(widget->display, widget->backbuffer, widget->frame_gc, x + absx, y + absy);
}

int gdot_draw_line (GeedotWidget *widget, unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2) {
	int absx, absy;
	absx = gdot_widget_absolute_x(widget);
	absy = gdot_widget_absolute_y(widget);

	XDrawLine(widget->display, widget->backbuffer, widget->frame_gc, x1 + absx, y1 + absy, x2 + absx, y2 + absy); 
}

int gdot_draw_rect (GeedotWidget *widget, GeedotArea area) {
	int absx, absy;
	absx = gdot_widget_absolute_x(widget);
	absy = gdot_widget_absolute_y(widget);

	XDrawRectangle(widget->display, widget->backbuffer, widget->frame_gc, area.x + absx, area.y + absy, area.width, area.height);
}

int gdot_fill_rect (GeedotWidget *widget, GeedotArea area) {
	int absx, absy;
	absx = gdot_widget_absolute_x(widget);
	absy = gdot_widget_absolute_y(widget);

	XFillRectangle(widget->display, widget->backbuffer, widget->frame_gc, area.x + absx, area.y + absy, area.width, area.height);
}

int gdot_draw_oval (GeedotWidget *widget, GeedotArea area) {
}

int gdot_fill_oval (GeedotWidget *widget, GeedotArea area) {
}
