/* Geedot Toolkit - Widget set for Geedot Web Browser
 *   File: gdtoolkitpixmap.c - pixmap creation, drawing, and handling
 *   Author: Luke Crowthers
 *   Start Date: Feb, 2001
 *   Version: 0.1
 *   License: GPL
 */

#include <gdtoolkit.h>

GeedotWidget *gdot_add_pixmap (GeedotWidget *frame, GeedotArea area) {
	GeedotAction  action_temp;
	GeedotWidget *last_widget;

	gdot_widget_inherit(frame, frame->last_widget->widget);
	frame->last_widget->widget->owner = frame;
	frame->last_widget->widget->type = GEEDOT_BUTTON;
	frame->last_widget->widget->is_active = True;
	frame->last_widget->widget->is_visible = True;
	frame->last_widget->widget->draw_package.redraw = GEEDOT_FUNCTION(gdot_redraw_pixmap);
	frame->last_widget->widget->draw_package.redraw_data = frame->last_widget->widget;
	frame->last_widget->widget->area.x = area.x;
	frame->last_widget->widget->area.y = area.y;
	frame->last_widget->widget->area.width = area.width;
	frame->last_widget->widget->area.height = area.height;

	frame->last_widget->widget->first_widget = (GeedotWidgetList *) malloc(sizeof(GeedotWidgetList));
	frame->last_widget->widget->first_widget->widget = (GeedotWidget *) malloc(sizeof(GeedotWidget));
	frame->last_widget->widget->last_widget = frame->last_widget->widget->first_widget;

	frame->last_widget->widget->first_action = (GeedotActionList *) malloc(sizeof(GeedotActionList));
	frame->last_widget->widget->first_action->action = (GeedotAction *) malloc(sizeof(GeedotAction));
	frame->last_widget->widget->last_action = frame->last_widget->widget->first_action;

	frame->last_widget->widget->first_widget_action = (GeedotActionList *) malloc(sizeof(GeedotActionList));
	frame->last_widget->widget->first_widget_action->action = (GeedotAction *) malloc(sizeof(GeedotAction));
	frame->last_widget->widget->last_widget_action = frame->last_widget->widget->first_widget_action;

	frame->last_widget->widget->widget_data = (GeedotPixmap *) malloc(sizeof(GeedotPixmap));
	GEEDOT_PIXMAP(frame->last_widget->widget->widget_data)->pixmap = XCreatePixmap(frame->display, frame->drawable, area.width, area.height, DefaultDepth(frame->display, DefaultScreen(frame->display)));

	last_widget = frame->last_widget->widget;

	frame->last_widget->next = (GeedotWidgetList *) malloc(sizeof(GeedotWidgetList));
	frame->last_widget->next->widget = (GeedotWidget *) malloc(sizeof(GeedotWidget));
	frame->last_widget = frame->last_widget->next;

	return last_widget;
}

int gdot_redraw_pixmap (GeedotWidget *widget) {
	int absx = gdot_widget_absolute_x(widget);
	int absy = gdot_widget_absolute_y(widget);

	XCopyArea(widget->display, GEEDOT_PIXMAP(widget->widget_data)->pixmap, widget->backbuffer, widget->frame_gc, 0, 0, widget->area.width, widget->area.height, absx, absy);
	XCopyArea(widget->display, widget->backbuffer, widget->drawable, widget->frame_gc, absx, absy, widget->area.width, widget->area.height, absx, absy);
}
